using System;
using TestLib;
using System.Reflection;
using System.Threading;
using System.Collections.Generic;

namespace Demo2
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
      Assembly asm = Assembly.LoadFrom(@"D:\Events\Webcast105 (NET9)\TestLib\bin\Debug\TestLib.dll");
      Type [] arrTypes = asm.GetTypes();

      foreach(Type t in arrTypes)
      {
        if (t.Name == "TestClass")
        {
          Console.WriteLine("   --- " + t.Name);

          MethodInfo mi = t.GetMethod("TestLocal");

          MethodBody mb = mi.GetMethodBody();
          Console.WriteLine("\r\nMethode: {0}", mi);

          Console.WriteLine("Lokale Variablen (initialisiert): {0}", mb.InitLocals);
          Console.WriteLine("Maximale Anzahl von Elementen auf dem Stack: {0}", mb.MaxStackSize);
         
          foreach(LocalVariableInfo lvi in mb.LocalVariables)
          {
            Console.WriteLine("Index: {0}   Typ: {1}   Pinned: {2}", 
              lvi.LocalIndex, lvi.LocalType.ToString(), lvi.IsPinned);
          }
        }
      }
    }
	}
}
