using System;
using System.Reflection;
using System.Threading;
using TestLib;

namespace Demo1
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
      TestClass test = new TestClass();

      // Welche Assemblies gibt's hier eigentlich?
      Assembly[] myAssemblies = Thread.GetDomain().GetAssemblies();
      
      for(int i = 0; i < myAssemblies.Length; i++)
      {
        Console.Write("Name : {0}   ", myAssemblies[i].GetName().Name);
        Console.WriteLine("Version: {0}", myAssemblies[i].GetName().Version.ToString());
     
        if(myAssemblies[i].GetName().Name == "TestLib")
        {
          Type [] arrTypes = myAssemblies[i].GetTypes();

          foreach(Type t in arrTypes)
          {
            Console.WriteLine("   --- " + t.Name);
            
            MethodInfo [] arrMethod = t.GetMethods(/*BindingFlags.NonPublic | BindingFlags.Instance*/);

            foreach(MethodInfo mi in arrMethod)
            {
              Console.WriteLine("      +++ " + mi.Name + "   Return: " + mi.ReturnType.ToString());

              ParameterInfo [] arrParam = mi.GetParameters();

              foreach(ParameterInfo pi in arrParam)
              {
                Console.WriteLine("         *** " + pi.Name + "  (" + pi.ParameterType.ToString() + ")");
              }
            }
          }
        }
      }
		}
	}
}
